<template lang="pug">
component.btn( :is='as' :to='to' @click='handleClick' @mouseover='mouseOver' @mouseout='mouseOut' )
	.bg.is-flex( :class='type' )
		bg( :content='content' :type='type' :hover='onHover' :width='width' :fullwidth='fullwidth' )
	.content-wrapper.is-flex.is-align-items-center.is-justify-content-center
		.img.is-flex( v-if='img' )
			component( :is='img' )
		slot
</template>

<script>
export default {
	components: {
		Bg: () => import("./Bg.vue")
	},
	props: {
		type: {
			type: String,
			default: "primary",
			validator: val => [ "primary", "yellow", "grey" ].includes(val)
		},
		asset: {
			type: String,
			default: ""
		},
		as: {
			default: "div",
			validator: val => [ "a", "div", "router-link", "button" ].includes(val)
		},
		to: [ String, Object ],
		width: Number,
		fullwidth: Boolean
	},
	data() {
		return {
			content: "",
			onHover: false
		}
	},
	computed: {
		img() {
			return this.asset ? () => import(`svg/${this.asset}.svg`) : null
		}
	},
	methods: {
		setContent() {
			this.content = this.$slots.default?.[0]?.text + (this.asset ? "KKK" : "")
		},
		handleClick() {
			this.$emit("click")
		},
		mouseOver() {
			this.onHover = true
		},
		mouseOut() {
			this.onHover = false
		}
	},
	updated() {
		this.setContent()
	},
	mounted() {
		this.setContent()

		window.addEventListener("resize", this.setContent)
	}
}
</script>

<style lang="scss" scoped>
.btn {
	padding: 0;
	background: transparent;
	border: none;
	position: relative;
	cursor: pointer;
	transition: margin-bottom .1s ease-in-out;
	outline: none!important;
	&:hover {
		.primary + .content-wrapper {
			color: #410826;
			.img {
				svg {
					fill: #410826;
				}
			}
		}
		.yellow + .content-wrapper {
			color: #7A380C;
			.img {
				svg {
					fill: #7A380C;
				}
			}
		}
	}

	&:active {
		margin-bottom: calc(.625rem - .125rem);
		.bg {
			margin-top: .125rem;
			&::before {
				top: 0;
			}
		}
	}
}

.bg {
	position: relative;
	transition: margin-top .1s ease-in-out;
	svg {
		z-index: 1;
	}

	&.primary,
	&.yellow {
		&::before {
			content: "";
			display: block;
			width: 95%;
			height: 100%;
			margin: 0 auto;
			border-radius: 10px;
			position: absolute;
			top: .25rem;
			right: 0;
			left: 0;
			z-index: 0;
			transition: top .1s ease-in-out;
		}
	}
	&.primary {
		&::before {
			background: #861651;
			box-shadow: 0px 11px 25px rgba(0, 0, 0, 0.47), 0px 8px 24px rgba(237, 87, 74, 0.35);
		}
	}
	&.yellow {
		&::before {
			background: #B15618;
			box-shadow: 0px 11px 25px rgba(0, 0, 0, 0.47), 0px 8px 24px rgba(200, 96, 25, 0.52);
		}
	}
}

.content-wrapper {
	font-size: .8125rem;
	font-weight: 800;
	text-transform: uppercase;
	color: #fff;
	width: 100%;
	height: 100%;
	position: absolute;
	top: 0;
	left: 0;
	user-select: none;
	z-index: 2;
	transition: color .2s ease-in-out;
	.img {
		width: 1.125rem;
		margin-right: .5rem;
		svg::v-deep {
			fill: #fff;
			transition: fill .2s ease-in-out;
		}
	}
}
</style>